# adaption-visualised-weenink-10m.praat
# djmw 20050310, 20050530, 20050719, 20060925

draw_color = 1
savedir$ = "/home/david/tex/thesis/anorm/"

Create TableOfReal (Weenink 1985)... Men
To TableOfReal (means by row labels)... no
tm = selected ("TableOfReal")
Copy... tm2
tm2 = selected ("TableOfReal")
plus tm
Append columns
tv = selected ("TableOfReal")
select tm2
Remove

x1=100
x2=900
y1=500
y2=2500

x = 730
y = 1300
xr = 798
yr = 1340
delta = 1
Font size... 10

# 1 means + new ?
# 2 distances
# 3 minimum distance a
# 4 move means (arrows)
# 5 new positions
# 6 ready

a = 2.54

procedure setinnervp index
  #drawing order: left to right
  
  height= 17/a
  nx = 2
  ny = 3
  width = nx * height / ny
  xwp = width / nx
  ywp = height / ny
  xlo = 1/7 * xwp
  xro = xlo
  ybo = 1/6 * ywp
  yto = ybo

  if index > 0
    irow = (index - 1) div nx + 1
    icol = index - (irow - 1) * nx
    vpx1 = (icol-1) * xwp + xlo
    vpx2 = icol * xwp - xro
    vpy1 = (irow - 1) * ywp + yto
    vpy2 = irow * ywp - ybo
  else
    vpx1 = xlo
    vpx2 = width - xro
    vpy1 = yto
    vpy2 = height - ybo
  endif
  Select inner viewport... vpx1 vpx2 vpy1 vpy2
endproc

procedure save file$
  path$ = "'savedir$'"+"'file$'"
  Write to EPS file... 'path$'.eps
  system epstopdf --outfile='path$'.pdf 'path$'.eps
endproc 

procedure draw_reference index innervp texttop$
  if innervp=1 
    call setinnervp index
  endif
  select tm
  Draw scatter plot... 1 2 0 0 x1 x2 y1 y2 10 y + no
  # decorations
  Draw inner box
  Marks bottom every... 1 100 n y n
  Marks left every... 1 500 n y n
  Text bottom... n %F__1_
  Text special... x1-50 Centre 1500 Half Times 10 90 %F__2_
  Text top... no 'texttop$'
endproc

Erase all

# plaatje 1
call draw_reference 1 1 (a)
if draw_color = 1
  Red
endif
Text... x Centre y Half ?
Black

# plaatje 2
# afstanden

call draw_reference 2 1 (b)
select tv
Copy... tv2
tv2 = selected ("TableOfReal")
for i to 12
  Set value... i 1 x
  Set value... i 2 y
endfor
if draw_color = 1
  Red
endif
Text... x Centre y Half ?
Draw vectors... 1 2 4 5  x1 x2 y1 y2 Arrow 0 n
Black


# plaatje 3
# een a ipv ?
call draw_reference 3 1 (c)
select tv2
if draw_color = 1
  Red
endif
Dotted line
Draw vectors... 1 2 4 5  x1 x2 y1 y2 Arrow 0 n
Plain line
if draw_color = 1
  Blue
endif
Line width... 3
Draw arrow... x y xr yr
Line width... 1
Text... x Centre y Half ?
Black


# plaatje 4
# vector
call draw_reference 4 1 (d)
if draw_color = 1
  Blue
endif
Text... x Centre y Half a
Draw arrow... x y xr yr
Black

#plaatje 5
# allemaal vectors
ddx = xr - x
ddy = yr - y

call draw_reference 5 1 (e)
select tv
Copy... tv3
tv3 = selected ("TableOfReal")
Formula... if col=4 then self-delta*ddx else if col=5 then self - delta*ddy else self fi fi
if draw_color = 1
  Blue
endif
Line width... 2
Draw vectors... 1 2 4 5  x1 x2 y1 y2 Arrow 0 n
Line width... 1
Text... x Centre y Half a
Black

#plaatje 6
# nieuwe toestand
select tm
Formula... if col=1 or col=2 then TableOfReal_tv3[row,col+3] else self endif
call draw_reference 6 1 (f)
Grey
select tv3
Draw scatter plot... 1 2 0 0  x1 x2 y1 y2 8 y + no
Black

call setinnervp 0
#call save adaption-visualised-weenink-10m
yvp = (6.70997375328084-(-0.017060367454))*2.54
xvp = (4.726565429321334-(-0.2646231721034871))*2.54
printline widthxheight = 'xvp' x 'yvp'

# plaatje (e) opnieuw voor voorpagina

procedure draw_e
  Erase all
  Select outer viewport... 0 10/a   0 10/a
  call draw_reference 5 0
  select tv
  Copy... tv3
  tv3 = selected ("TableOfReal")
  ddx = xr - x
  ddy = yr - y

  Formula... if col=4 then self-delta*ddx else if col=5 then self - delta*ddy else self fi fi
#  if draw_color = 1
#    Blue
#  endif
  Line width... 1
  Draw vectors... 1 2 4 5  x1 x2 y1 y2 Arrow 0 n
  Line width... 1
  Text... x Centre y Half a
  Black
#  call save adaption-visualised-weenink-10m_e
endproc

procedure draw_f
  Erase all
  Select outer viewport... 0 10/a   0 10/a
  call draw_reference 6 0
  Grey
  select tv3
  Draw scatter plot... 1 2 0 0  x1 x2 y1 y2 8 y + no
  # reduce the x of column 4 a little bit
  Formula... if col=4 then self+10 else if col=1 then self-10 else self endif endif
  Draw vectors... 1 2 4 5  x1 x2 y1 y2 Arrow 0 n
  Black
  call save adaption-visualised-weenink-10m_ef
endproc

call draw_f
