#zw-p_normalisation.praat
#
# 20020212 djmw
#
# version 0: average per speaker

dir$="/u/david/TIMIT/scripts"
t$="m"
tt$=t$
tn$="mn"
r$="r"
result$="result"
speakers$="s438"
n=10
na=10
np=1
colselect$ = "27:44"
#colselect$ = "9:62" 
!clearinfo
printline ---Column selection 'colselect$'

procedure readFromFiles
	Read from file... /u/david/TIMIT/dr0/barks_d0R0SmPv1A1_03.TableOfReal
	Rename... table
	Read from file... /u/david/TIMIT/dr0/barks_d0R0SmPv1A1_03_sp.Categories
	Rename... 'speakers$'
endproc 

call readFromFiles

# select the appropriate column from the table
# bandfiterframes 9:62, central part 27:44

select TableOfReal table
To TableOfReal (rows)... 'colselect$' 1
Rename... 't$'
select TableOfReal table
Remove

normalize=1
if (normalize = 1)
! multiple replications per vowel
  select TableOfReal 't$'
  Extract row labels
  To Categories
  select Strings 't$'
  Remove
  tn$=t$+"n"
  execute 'dir$'/normalize_table.praat 't$' 'speakers$' 't$' 'tn$'
  tt$=tn$
elsif (normalize = 2)
  tt$ = 't$'+"n"
  tts$= 'speakers$'+ "n"
  execute 'dir$'/toOneRepresentationPerVowel.praat 't$' 'speakers$' 'tt$' 'tts$'  
endif


select TableOfReal 'tt$'
To Discriminant

procedure get_fc  dis$ tab$ alpha minp row col
  select Discriminant 'dis$'
  plus TableOfReal 'tab$'
  To ClassificationTable (dw)... no no 'alpha' 'minp'
  select ClassificationTable 'dis$'_'tab$'
  To Confusion
  fc = Get fraction correct
  if fc > fcBest'col'
    fcBest'col' = fc
	alphaBest'col' = alpha
	pBest'col' = minp
  endif
  select TableOfReal 'result$'
  Set value... 'row' 'col' 'fc'
  select ClassificationTable 'dis$'_'tab$'
  plus TableOfReal 'dis$'_'tab$'
  plus Confusion 'dis$'_'tab$'
  Remove
endproc

Create TableOfReal... 'result$' n*na*np 2
Set column label (index)... 1 m
Set column label (index)... 2 r

for i to 2
  alphaBest'i' = 0
  pBest'i'=0
  fcBest'i'=0
endfor

row=1

for i to n

  select TableOfReal 't$'
  Randomize rows
  Rename... 'r$'

  for j to na
    alpha = -(j-1) / na
    for k to np
      minp = k/(np + 1)
      call get_fc 'tt$' 't$' 'alpha' 'minp' 'row' 1
      call get_fc 'tt$' 'r$' 'alpha' 'minp' 'row' 2
	  select TableOfReal 'result$'
	  Set row label (index)... 'row' 'i'_'j'_'k'
      row=row+1
    endfor
  endfor
  select TableOfReal 'r$'
  Remove
endfor

select TableOfReal 'result$'

for i to 2
  alphaBest$ = fixed$(alphaBest'i', 3)
  pBest$ = fixed$(pBest'i', 3)
  fcBest$ =  fixed$(fcBest'i', 3)
  mean = Get column mean (index)... 'i'
  stdev = Get column stdev (index)... 'i'
  mean$ = fixed$ (mean, 3)
  stdev$ = fixed$ (stdev, 3)
  printline mean'i' = 'mean$', stdev'i' = 'stdev$' ,alphaBest'i' = 'alphaBest$',
  ... pBest'i' = 'pBest$', fcBest'i' = 'fcBest$'
endfor
