# pca-discriminant.praat
# djmw 20040303

savedir$ = "/home/david/tex/thesis/cart/"
include /home/david/tex/praat_procedures.praat

procedure readfromfile
  Read from file... /home/david/TIMIT/dr0/barks_d0R0SmP00A1_01.TableOfReal
  Rename... d0
endproc

procedure analyze
  select TableOfReal d0  
  To PCA
  plus TableOfReal d0
  To Configuration... 0
  Rename... pca
  pca_nmax = Get number of columns
  To TableOfReal
  
  select TableOfReal d0
  To Discriminant
  plus TableOfReal d0
  To Configuration... 0
  Rename... dis
  dis_nmax = Get number of columns
  To TableOfReal
  
  Create TableOfReal... result pca_nmax 3
  Set column label (index)... 1 number of components
  Set column label (index)... 2 pca_fc
  Set column label (index)... 3 dis_fc
  
  for i to pca_nmax
  
    call fc pca 'i'
    select TableOfReal result
    pca_fc = fc_fc
    Set row label (index)... i 'i'
    Set value... i 1 i
    Set value... i 2 pca_fc
  
    call fc dis 'i'
    dis_fc = fc_fc
    select TableOfReal result
    Set value... i 3 dis_fc
   
    printline n = 'i', pca_fc = 'pca_fc', dis_fc = 'dis_fc'
  endfor
endproc

procedure fc fc_tablein$ fc_nc
  select TableOfReal 'fc_tablein$'
  Select columns where row... 1:'fc_nc' 1
  Rename... tmp
  To Discriminant
  plus TableOfReal tmp
  To ClassificationTable... y y
  Rename... tmp
  To Confusion
  Rename... tmp
  fc_fc = Get fraction correct
  select Confusion tmp
  plus ClassificationTable tmp
  plus Discriminant tmp
  plus TableOfReal tmp
  Remove
endproc

procedure pc_select
  select TableOfReal d0
  plus PCA d0
  To Configuration... 9
  Rename... barks_d0R0SmP00A1_01_pc9
  To TableOfReal
  Write to binary file... 'savedir$'barks_d0R0SmP00A1_01_pc9.TableOfReal
  select Configuration barks_d0R0SmP00A1_01_pc9
  Remove
endproc

procedure draweigenvalues
  call vp_init 12 6 2 1 1
#  call vp_margins 0.5 0 0 0
  call vp_next
  select PCA d0
  Draw eigenvalues... 0 0 0 1 y n 2 + n
  Draw inner box
  Marks left every... 1 100 n y n
  One mark left... 0 y n n
  One mark left... 1 y n n
  One mark bottom... 1 y y n
  One mark bottom... 9 y y n
  One mark bottom... 18 y y n
  # otherwise the text is too far off!
#  Text special... -3 Centre 0.5 Half Times 10 90 Eigenvalue
  Text left... y Fractional eigenvalue
  Text top... n (a)
  call vp_next
  select Discriminant d0
  Draw eigenvalues... 0 0 0 1 y n 2 + n
  Draw inner box
  Marks left every... 1 1 n y n
  One mark left... 0 y n n
  One mark left... 1 y n n
  One mark bottom... 1 y y n
  One mark bottom... 9 y y n
  One mark bottom... 18 y y n
#  Text special... -3 Centre 0.5 Half Times 10 90 Eigenvalue
  Text left... y Fractional eigenvalue
  Text top... n (b)
endproc

#call readfromfile
#call analyze
call draweigenvalues

#call pc_select


call vp_initr 12 8 1 1 1
call vp_margins 0 0 0 0
call vp_next

select TableOfReal result
res_max = Get number of rows
Draw scatter plot... 1 2 0 0 0 19 0.2 0.5 12 no - no
Draw scatter plot... 1 3 0 0 0 19 0.2 0.5 12 no + no
Draw inner box
Marks left every... 1 0.1 y y n
One mark bottom... 1 y y n
One mark bottom... 18 y y n
One mark bottom... 9 y y y
Text bottom... y Number of components
Text left... y Fraction correct
max = Get value... res_max 2
max$ = fixed$(max,3)
One mark right... 'max' n y n 'max$'
  Text top... n (c)

call save pca-discriminant-fractionscorrect


  
  
  
