# timit_process_table_test_vigilance.praat
# djmw 20040402
# djmw 20050426 Latest modification

savedir$ = "/home/david/tex/thesis/cart/"
include /home/david/tex/praat_procedures.praat

#Read from file... /home/david/tex/thesis/cart/timit_test_vigilance_learningrate_2-2004-04-06.TableOfReal
Read from file... /home/david/tex/thesis/cart/timit_test_vigilance_learningrate_3-2005-04-24.TableOfReal
Rename... onoff

# rep, epoch, rho, beta, frc, commit, track, frct
#
# 1-rep, 2-rho, 3-beta, 4-frc, 5-commit, 6-frct

# select results after maximum number of epochs (20)
#Select columns where row... "1 3:6 8" self[2] = 200 and self[7] = 1
Extract rows where... self[2] = 10 and self[7] = 1
tmp = selected ("TableOfReal")
Extract column ranges... 1 3:6 8
Rename... on
committed_mean = Get column mean (index)... 5
printline on: committed: 'committed_mean'
select tmp
Remove


select TableOfReal onoff
#Select columns where row... "1 3:6 8" self[2] = 200 and self[7]=0
Extract rows where... self[2] = 10 and self[7] = 0
tmp = selected ("TableOfReal")
Extract column ranges... 1 3:6 8
Rename... off
committed_mean = Get column mean (index)... 5
printline off: committed: 'committed_mean'
select tmp
Remove

select TableOfReal on
plus TableOfReal off
Sort by column... 2 3

nrep = 10
nrho = 7
rhob = 0.7
rhoe = 1
drho = (rhoe - rhob) / (nrho - 1)
betab = 0.05
betae = 1
nbeta = 5
dbeta = (betae - betab) / (nbeta - 1)

# Treat repetitions as one group and let Discriminant calculate the group centroids.
procedure extract_centroids tablein$
  select TableOfReal 'tablein$'
  nrows = Get number of rows
  for i to nrows
    j = ((i-1) div nrep)
    Set row label (index)... i 'j'
  endfor
#  Remove column (index)... 1
  To Discriminant
  Extract group centroids
  Remove column (index)... 1
  Rename... 'tablein$'r
  To Correlation
  select Discriminant 'tablein$'
  Remove
endproc

procedure label tablein2$ index rb dr
  select TableOfReal 'tablein2$'
  nrows = Get number of rows
  for i to nrows
    r = TableOfReal_'tablein2$'[i,index]
    j = (round ((r-rb)/dr)) + 1
    j$ = fixed$ (j,0)
    Set row label (index)... i 'j$'
  endfor  
endproc


procedure extract_rho_by_beta tablein4$
  select TableOfReal 'tablein4$'
  nrows = Get number of rows
  Create TableOfReal... 'tablein4$'_rbya nrho nbeta
  for irow to nrows
    rho = TableOfReal_'tablein4$'[irow,1]
    beta = TableOfReal_'tablein4$'[irow,2]
    frc = TableOfReal_'tablein4$'[irow,3]
    i = round ((rho  - rhob) / drho) + 1
    j = round ((beta - betab) / dbeta) + 1
    rho$ = fixed$ (rho, 2)
    beta$ = fixed$ (beta, 2)
printline 'irow' 'i' 'j' 'rho$' 'beta$'
    select TableOfReal 'tablein4$'_rbya
    # sel row and column labels again and again
    Set row label (index)... i 'rho$'
    Set column label (index)... j 'beta$'
    Set value... i j 'frc'
  endfor   

endproc


procedure scatter_matrix tablein3$
  call extract_centroids 'tablein3$'
  # result is 'tablein3$'r
  call vp_init 10 10 1 1 1
  select TableOfReal 'tablein3$'r
  Copy... 'tablein3$'r_rho
  call label 'tablein3$'r_rho 1 'rhob' 'drho'
  call vp_margins -0.5 -0.5 -0.5 -0.5
  call vp_next
  Draw scatter plot matrix... 0 0 0.1
#  call vp_margins -0.5 -0.5 -0.5 -0.5

  select TableOfReal 'tablein3$'r
  Copy...  'tablein3$'r_beta
  call label 'tablein3$'r_beta 2 'betab' 'dbeta'
  call vp_initr 10 10 1 1 1
  call vp_next
  Draw scatter plot matrix... 0 0 0.1

  call save timit-'tablein3$'rl-rho-beta
endproc

procedure draw_beta_vs_frc tablein6$
  select TableOfReal 'tablein6$'
  Draw scatter plot... 2 3 0 0 -0.1 1.1 0 1.1 12 y + n
  Draw inner box
  Marks bottom every... 1 0.1 n y n
  One mark bottom... 0 y n n
  One mark bottom... 0.5 y n n
  One mark bottom... 1 y n n
  Marks left every... 1 0.1 n y n
  One mark left... 0 y n n
  One mark left... 0.5 y n n
  One mark left... 1 y n n
  Text left... y Fraction correct (train)  
  Text bottom... y Learning rate \be  
endproc

procedure draw_rho_vs_frc tablein7$
  select TableOfReal 'tablein7$'
  Draw scatter plot... 1 3 0 0 0.5 1.1 0 1.1 12 n + n
  Draw inner box
  Marks bottom every... 1 0.1 n y n
#  One mark bottom... 0 y n n
  One mark bottom... 0.6 y n n
  One mark bottom... 1 y n n
  Marks left every... 1 0.1 n y n
  One mark left... 0 y n n
  One mark left... 0.5 y n n
  One mark left... 1 y n n
  Text left... y Fraction correct (train) 
  Text bottom... y Vigilance \ro 
endproc

procedure draw_frc_vs_frct tablein8$
  select TableOfReal 'tablein8$'
  Draw scatter plot... 3 5 0 0 -0.1 1.1 -0.1 1.1 12 y + n
  Draw inner box
  Marks bottom every... 1 0.1 n y n
  One mark bottom... 0 y n n
  One mark bottom... 0.5 y n n
  One mark bottom... 1 y n n
  Marks left every... 1 0.1 n y n
  One mark left... 0 y n n
  One mark left... 0.5 y n n
  One mark left... 1 y n n
  Text left... y Fraction correct (test) 
  Text bottom... y  Fraction correct (train)
  Dotted line
  Draw line... 0 0 1 1
  Plain line
endproc

procedure draw_frc_vs_commit tablein9$
  select TableOfReal 'tablein9$'
  Draw scatter plot... 3 4 0 0 -0.1 1.1 0 3000 12 y + n
  Draw inner box
  Marks bottom every... 1 100 n y n
  One mark bottom... 0 y n n
  One mark bottom... 0.5 y n n
  One mark bottom... 1 y n n
  Marks left every... 1 100 n y n
  One mark left... 0 y n n
  One mark left... 500 y n n
  One mark left... 1300 y n n
  Text left... y Committed nodes 
  Text bottom... y  Fraction correct (train) 
endproc

call scatter_matrix on

pause draw off matrices

call scatter_matrix off

pause draw 2 by 2 on

procedure draw_twobytwo tablein10$
  call vp_init 12 12 2 2 1
  call vp_next
  call draw_rho_vs_frc 'tablein10$'
  Text top... n (a)
  call vp_next
  call draw_beta_vs_frc 'tablein10$'
  Text top... n (b)
  call vp_next
  call draw_frc_vs_frct 'tablein10$'
  Text top... n (c)
  call vp_next
  call draw_frc_vs_commit 'tablein10$'
  Text top... n (d)
endproc

call draw_twobytwo onr_rho
call save cart-timit-mt-on-2by2

pause draw 2 by 2 off

call draw_twobytwo offr_rho
call save cart-timit-mt-off-2by2

# New Correlation: upper = on ; lower = off

select Correlation onr
Copy... onoffr
Formula... if row > col then Correlation_offr[row,col] else self fi
To TableOfReal
call latex_table onoffr 3
Remove



    
