# variance_due_to_f0.praat

procedure create_sound f0
  Create Sound from tone complex... 1 0 0.1 11025 Sine f0 0 0 0
  To Spectrum... no
  Formula... if x > 100 then 100 * self / x else self fi
  To Sound
  Rename... 6
  select Sound 1
  plus Spectrum 1
  Remove
endproc

nf = 80

Create TableOfReal... results nf 19
df = 5
f1_Hz = 80
f1_Bark = hertzToBark(f1_Hz)
f2_Hz = 450
f2_Bark = hertzToBark(f2_Hz)
df_Bark = (f2_Bark - f1_Bark)/(nf-1)
for i to nf
  f_Bark = f1_Bark +  (i-1)*df_Bark
  f_Hz = barkToHertz (f_Bark)
  call create_sound f_Hz
  select Sound 6
  To BarkFilter... 0.015 0.005 1 1 0
  Equalize intensities... 80
  select TableOfReal results
  Set row label (index)... i 'i'
  plus BarkFilter 6
  Copy frames into rows... 8 8 i 1
  select Sound 6
  plus BarkFilter 6
  Remove
endfor  
