#
h = Horizontal mm to wc... 10
v = Vertical mm to wc... 10
v_scale = h/v

procedure draw_arrow x1 y1 r1 x2 y2 r2
  phi = arctan2 (y2 - y1, x2 - x1)
  xf = x1 + r1 * cos (phi)
  yf = y1 + r1 * sin (phi)
  xt = x2 - r2 * cos (phi)
  yt = y2 - r2 * sin (phi)
  Draw arrow... 'xf' 'yf' 'xt' 'yt'
endproc

Erase all
Viewport... 0 4 0 4
Axes... 0 1 0 1

xc1 = 0.15
yc1 = 0.1
r   = 0.03
xc2 = 0.15
yc2 = 0.4
xc3 = 0.35
yc3 = 0.25

xc4 = 0.5
yc4 = yc3

Draw inner box
Draw circle... xc1 yc1 r
Draw circle... xc2 yc2 r
Draw circle... xc3 yc3 r

call draw_arrow xc1 yc1 r xc3 yc3 r
call draw_arrow xc2 yc2 r xc3 yc3 r
call draw_arrow xc3 yc3 r xc4 yc4 r

Text... xc1-1.5*r Right yc1 Half x_2
Text... xc1-1.5*r Right yc2 Half x_1
Text... xc1 Centre yc1+(yc2-yc1)/2 Half input
Text... xc4 Right yc4-r Top output

xr1 = 0.45
yr1 = 0.45
xr2 = 0.9
yr2 = 0.9
Draw rectangle... xr1 xr2 yr1 yr2
Dashed line
Line width... 2
Draw line... xr1 yr1+0.1 xr2 yr2-0.1
Line width... 1
Plain line
Text... xr1+(xr2-xr1)/3 Centre yr1-r Half %x_1
Draw arrow... xr1+(xr2-xr1)/3+r yr1-r xr1+2*(xr2-xr1)/3 yr1-r
Text... xr1-r Centre yr1+(yr2-yr1)/3 Half %x_2
Draw arrow... xr1-r yr1+(yr2-yr1)/3+r xr1-r yr1+2*(yr2-yr1)/3

Text... xr1 Right yr1 Top (0,0)
Text... xr2 Left yr1 Top (1,0)