# draw_means.praat
# djmw 20050331
# djmw 20050406 Latest modification
# djmw 20060824 regular expression modified
# djmw 20060830 (cumm.)->(cum.)

savedir$ = "/home/david/tex/thesis/nn-bias2/"
datadir$ = "/home/david/tex/thesis/data/"

procedure save file$
  filepath$ = "'savedir$'"+"'file$'"
  Write to EPS file... 'filepath$'.eps
  system epstopdf --outfile='filepath$'.pdf 'filepath$'.eps
endproc

a = 1/2.45
x0 = 1.5
y0 = 1.5
Plain line

Create TableOfReal... index 1 20
for i to 20
  Set value... 1 i i
endfor
index = selected ("TableOfReal")

Read from file... 'datadir$'barks_total_frame2_mf_meansperspeaker.TableOfReal
tmf = selected ("TableOfReal")

Extract row ranges... 1:8078
tm = selected ("TableOfReal")
To TableOfReal (means by row labels)... n
Rename... tma
tma = selected ("TableOfReal")

select tmf
Extract row ranges... 8079:11579
tf = selected ("TableOfReal")
To TableOfReal (means by row labels)... n
Rename... tfa
tfa = selected ("TableOfReal")

procedure get_one_global_average t_id
  select t_id
  Copy... tmp
  Change row labels... .* a 1 Regular Expressions
  To TableOfReal (means by row labels)... n
  tc = selected ("TableOfReal")
  select TableOfReal tmp
  Remove
endproc

procedure get_global_averages m_id f_id
  call get_one_global_average m_id
  tam = tc
  call get_one_global_average f_id
  taf = tc
  select tam
  plus taf
  Append
  global_averages = selected ("TableOfReal")
  Set row label (index)... 1 m
  Set row label (index)... 2 w
  select tam
  plus taf
  Remove
endproc

procedure get_global_averages_procrustes m_id f_id p_id
  select f_id
  To Configuration
  ctf = selected ("Configuration")
  plus p_id
  To Configuration
  ctftmp = selected ("Configuration")
  To TableOfReal
  tfp = selected ("TableOfReal")
  select ctf
  plus ctftmp
  Remove

  call get_global_averages m_id tfp
endproc

#  p -> Procrustes
# tfap -> TableOfReal tfa, after Procrustes transform
procedure procrustes
  select tma
  plus tfa
  To Configuration
  c1 = selected ("Configuration", 1)
  c2 = selected ("Configuration", 2)
  To Procrustes... n
  p = selected ("Procrustes")
  plus c2
  To Configuration
  c3 = selected ("Configuration")
  To TableOfReal
  tfap = selected ("TableOfReal")
  select c1
  plus c2
  plus c3
  Remove
endproc

procedure common_pca_space
  select tma
  plus tfa
  Append
  tmfa = selected ("TableOfReal")
  To PCA
  pca = selected ("PCA")
  plus global_averages
  To Configuration... 2
  cglobal = selected ("Configuration")
  select pca
  plus tma
  To Configuration... 2
  cma = selected ("Configuration")
  select pca
  plus tfa
  To Configuration... 2
  cfa = selected ("Configuration")
  plus cma
  To TableOfReal
  t1 = selected ("TableOfReal", 1)
  t2 = selected ("TableOfReal", 2)

  call procrustes
  select tfap
  plus pca
  To Configuration... 2
  cp = selected ("Configuration")
  To TableOfReal
  t3  = selected ("TableOfReal")
  plus t1
  plus t2
  Append columns
  # col 1,2: male
  # col 3,4: female
  # col 5,6: female after procrustes
  t4 = selected ("TableOfReal")

# Get the 2x2 Procrustes
#  select cma


  Erase all
  lx = 11*12/13.4
  ly = 15
  ddx = 1
  ddy = 1
  x1 = 10
  x2 = 2.5
  y1 = x1 * (130-90)/(100-30)
  vxmin = x0
  vxmax = x0+x1
  vymin = y0
  vymax = y0 + y1
  Select inner viewport... vxmin*a vxmax*a vymin*a vymax*a
# Draw vectors... 1 2 3 4 -100 -30 90 130 Arrow 10 y
  Draw vectors... 1 2 3 4 -100 -30 90 130 Line 10 y
  # dotted line from female to procrustes transformed
  Dotted line
  Draw vectors... 3 4 5 6 -100 -30 90 130 Line 0 n
  Plain line
  select cglobal
  Draw... 1 2 -100 -30 90 130 10 y + n
  Text bottom... n pc1
  Text left... n pc2
  Marks bottom every... 1 10 n y n
  Marks left every... 1 10 n y n
  Text top... n (a)

# Red
#  select cp
#  Draw... 1 2 -100 -30 90 130 12 n + n
#  Black

  vxmax = x0 + x1/2 - ddx/2
  vymin = vymax + ddy
  vymax = vymin + y1/2
  select t4
  Select inner viewport... vxmin*a vxmax*a vymin*a vymax*a
  select pca
  Plain line
  Draw eigenvector... 1 n 0 0 -0.5 0.5 1 + y y
  Marks bottom every... 1 1 n y n
  Marks left every... 1 0.1 n y n
  Dotted line
  Draw eigenvector... 2 n 0 0 -0.5 0.5 1 + y n
  Plain line
  Text top... n (b)

  vxmax = x0 + x1
  vxmin = vxmax - x1/2 + ddx/2
  Select inner viewport... vxmin*a vxmax*a vymin*a vymax*a
  Draw eigenvalues... 0 0 0.5 1.05 y y 1 + n
  Draw inner box
  Marks right every... 1 0.1 n y n
  One mark right... 1 y n y
#  One mark right... 0.75 y y y
  One mark right... 0.5 y n n
  Marks bottom every... 1 1 n y n
  Text left... n Eigenvalues (cum.)
  Text bottom... y Eigenvalue index
  One mark bottom... 1 y n n
  One mark bottom... 18 y n n
  Text top... n (c)

  select t1
  plus t2
  plus t3
  plus cma
  plus cfa
  plus tmfa
  Remove
  vxmin = x0
  vxmax = vxmin + x1
  vymin = y0
  vymax = vymin + y1 + ddy + y1/2
  Select inner viewport... vxmin*a vxmax*a vymin*a vymax*a
  call save pc1-pc2-m-f-diff
endproc

procedure draw_means m_id f_id index_id savename$
  select m_id
  To Matrix
  mm_id = selected ("Matrix")

  select f_id
  To Matrix
  mf_id = selected ("Matrix")

  select global_averages
  To Matrix
  mglobal_id = selected ("Matrix")


  Erase all
  Black
  Font size... 10
  n = 21
  nx = 3
  ny = 7
  lx = 12*12/16
  ly = 14
  dx = lx/nx
  dy = ly/ny
  ddx = 0.3
  ddy = 0.3
  correction = 0
  for i to n
    iy  = (i-1) div nx + 1
    ix = (i-1) mod nx + 1
    vxmin = x0+(ix-1)*dx
    vxmax = vxmin+dx-ddx
    vymin = y0+(iy-1)*dy
    vymax = vymin + dy -ddy
    Select inner viewport... vxmin*a vxmax*a vymin*a vymax*a
    if (i = 11)
      correction = 1
      select mglobal_id
      Draw rows... 0 0 1-0.1 1+0.1 40 80  
      Dotted line
      Draw rows... 0 0 2-0.1 2+0.1 40 80
      Plain line
      label$ = ".."
    else
      select index_id
      ilabel = Get value... 1 i-correction
      select m_id
      label$ = Get row label... ilabel
      select mm_id
      Draw rows... 0 0 ilabel-0.1 ilabel+0.1 40 80
      select mf_id
      Dotted line
      Draw rows... 0 0 ilabel-0.1 ilabel+0.1 40 80
      Plain line
    endif
    Draw inner box
    Marks bottom every... 1 1 n y n
    Text... 16 Centre 72 Half 'label$'
    if (iy mod 2) = 1
      # links
      if ix = 1
        Marks left every... 1 10 n y n
        One mark left... 80 y n n
        One mark left... 40 y n n
        Text left... n dB
      endif
    else
      if ix = nx
        Marks right every... 1 10 n y n
        One mark right... 80 y n n
        One mark right... 40 y n n
        Text right... n dB
      endif
    endif
    if iy = ny
      One mark bottom... 1 y n n
      One mark bottom... 18 y n n
      Text bottom... n Filter number
    endif
  endfor
  vxmin = x0
  vxmax = vxmin + nx*dx - ddx
  vymin = y0
  vymax = vymin + ny*dy - ddy
  Select inner viewport... vxmin*a vxmax*a vymin*a vymax*a
#  call save 'savename$'
endproc

procedure eigenvector_decoration texttop$
  Draw inner box
  Marks bottom every... 1 1 n y n
  Marks left every... 1 0.2 n y n
  One mark left... 1 y n n
  One mark left... 0 y n y
  One mark left... -1 y n n
  One mark bottom... 1 y n n
  One mark bottom... 18 y n n
  Text bottom... n Filter number
  Text top... n 'texttop$'
endproc

procedure draw_lda_plot
  select tm
  To Discriminant
  m_dis = selected ("Discriminant")
  plus tma
  To Configuration... 2
  m_conf = selected ("Configuration")
  select tf
  To Discriminant
  f_dis = selected ("Discriminant")
  plus tfa
  To Configuration... 2
  f_conf = selected ("Configuration")

  select m_dis
  plus tfa
  To Configuration... 2
  fm_conf = selected ("Configuration")
    
  select m_conf
  plus fm_conf
  To TableOfReal
  t1 = selected ("TableOfReal", 1)
  t2 = selected ("TableOfReal", 2)

  call procrustes
  select tfap
  plus m_dis
  To Configuration... 2
  cp = selected ("Configuration")
  To TableOfReal
  t3  = selected ("TableOfReal")
  plus t1
  plus t2
  Append columns
  t4 = selected ("TableOfReal")
  
  Erase all
  lx = 11*12/13.4
  ly = 15
  ddx = 1
  ddy = 1
  x1 = 10
  x2 = 2.5
  y1 = x1 * 35/45
  vxmin = x0
  vxmax = x0+x1
  vymin = y0
  vymax = y0 + y1
  Select inner viewport... vxmin*a vxmax*a vymin*a vymax*a
  
  select m_conf
  Draw... 1 2 -45 0 0 35 10 y + n
  select t4
  Draw vectors... 1 2 3 4 -45 0 0 35 Line 10 n
# Procrustes transformed
#  Dotted line
#  Draw vectors... 3 4 5 6 -45 0 0 35 Line 0 n
#  Plain line
  Draw inner box
  Text left...  n Eigenvector 2
  Text bottom...  n Eigenvector 1
  Text top... n (a)
  Marks bottom every... 1 10 n y n
  Marks left every... 1 10 n y n
  One mark bottom... -45 y n n
  One mark bottom... 0 y n n
  One mark left... 0 y n n
  One mark left... 35 y n n
  Text top... n (a)

  vxmax = x0 + x1/2 - ddx/2
  vymin = vymax + ddy
  vymax = vymin + y1/2
  select t4
  Select inner viewport... vxmin*a vxmax*a vymin*a vymax*a
  select m_dis
  Draw eigenvector... 1 n 0 0 -1 1 1 + y n
  Dotted line
  select f_dis
  Draw eigenvector... 1 n 0 0 -1 1 1 + y n
  Plain line
  call eigenvector_decoration (b)

  vxmax = x0 + x1
  vxmin = vxmax - x1/2 + ddx/2
  Select inner viewport... vxmin*a vxmax*a vymin*a vymax*a
  select m_dis
  Draw eigenvector... 2 n 0 0 -1 1 1 + y n
  Dotted line
  select f_dis
  Draw eigenvector... 2 n 0 0 -1 1 1 + y n
  Plain line
  call eigenvector_decoration (c)
  
  vxmin = x0
  vxmax = vxmin + x1
  vymin = y0
  vymax = vymin + y1 + ddy + y1/2
  Select inner viewport... vxmin*a vxmax*a vymin*a vymax*a
#  call save lda1-lda2-m-f-diff
endproc

call get_global_averages tm tf

call common_pca_space

#call draw_means tma tfa index m-f-spectral-means
#call draw_lda_plot

# for the procrustes-transformed f's also the global average must be recalculated.
#call procrustes
#call get_global_averages_procrustes tm tf p
#call draw_means tma tfap index m-f-spectral-means-p

breedte1=(5.277210884353741-0.02891156462585022)*2.54
hoogte1= (4.907839326206673-0.2233560090702955)*2.54
breedte2=(4.746598639455781-0.02891156462585022)*2.54
hoogte2= (6.592970521541949-0.2233560090702955)*2.54
breedte3 = (5.277210884353741-0.02891156462585022)*2.54
hoogte3= (6.171201814058957-0.2233560090702955)*2.54
printline  h,b 'hoogte1', 'breedte1', 'hoogte2', 'breedte2', 'hoogte3', 'breedte3'
