# pcs_PCA_LDA_m_f.praat
# djmw 20040622
# djmw 20050313 Last modification 

datadir$ = "/home/david/tex/thesis/data/"
savedir$ = "/home/david/tex/thesis/nn-bias2/"

a = 1/2.54
Black

procedure vp1
  Erase all
  x0 = 2
  x1 = x0
  dx = 4
  x2 = x1 + dx
  y1 = 1
  dy = 2
  y2 = y1 + dy
  dx2 = dx + 1.5 + dx
  Select inner viewport... a*x1 a*x2 a*y1 a*y2
endproc
procedure vp2
  x1 = x2 + 1.5
  x2 = x1 + dx
  Select inner viewport... a*x1 a*x2 a*y1 a*y2
endproc
procedure vp2a
  dx3 = dx2 - 2.5 - 2.5
  x1a = x0 + 2.5
  x2a = x1a + dx3
  y1 = y2 + 1.5
  y2 = y1 + 3
  Select inner viewport... a*x1a a*x2a a*y1 a*y2
endproc
procedure vp3 yscale
  x1 = x0
  x2 = x1 + dx2
  y1 = y2 + 1.5
  y2 = y1 + yscale * dx2
  Select inner viewport... a*x1 a*x2 a*y1 a*y2
endproc

procedure vpall
  x1 = x0
  x2 = x1 + dx + 1.5 + dx
  y1 = 1
  Select inner viewport... a*x1 a*x2 a*y1 a*y2
endproc
procedure save name$
  call vpall
  fname$ = savedir$+name$
  Write to EPS file... 'fname$'.eps
  system epstopdf --outfile='fname$'.pdf 'fname$'.eps
endproc

# gather the diff between the mean male and female bandfilter in a table of 1 row
procedure get_mf_overall_means mtable_id ftable_id
  Create TableOfReal... means_diff 1 18
  means_diff = selected ("TableOfReal")
  for i to 18
    select mtable_id
    v1 = Get column mean (index)... i
    select ftable_id
    v2 = Get column mean (index)... i
    diff = v2 - v1
    select means_diff
    Set value... 1 i diff
  endfor
endproc

procedure append_columns_configurations id1 id2
  select id1
  To TableOfReal
  idt1 = selected ("TableOfReal")
  select id2
  To TableOfReal
  idt2 = selected ("TableOfReal")
  plus idt1
  Append columns
  table_appended = selected ("TableOfReal")
  select idt1
  plus idt2
  Remove
endproc

procedure get_vector_from_diff pcadis_id f_centroid_id means_diff_table_id
  select means_diff_table_id
  name$ = selected$ ("TableOfReal")
  # project original
  select pcadis_id
  plus f_centroid_id
  To Configuration... 2
  conf_orig = selected ("Configuration")

  # project diff'd
  select f_centroid_id
  Copy... f_table_copy
  Formula... self - TableOfReal_'name$'[1,col]
  kanwegid = selected ("TableOfReal")
  plus pcadis_id
  To Configuration... 2
  conf_diff = selected ("Configuration")

  call append_columns_configurations conf_orig conf_diff
  select conf_orig
  plus conf_diff
  plus kanwegid 
  Remove
endproc

Read from file... 'datadir$'barks_total_frame2_mf_meansperspeaker.TableOfReal
mf = selected ("TableOfReal")
Read from file... 'datadir$'barks_total_frame2_mf_meansperspeaker_index.TableOfReal
index = selected ("TableOfReal")

# speaker 1-438 male, 439-630 female
lowerindexm = Get value... 1 1
upperindexm= Get value... 438 2
lowerindexf = Get value... 439 1
upperindexf= Get value... 630 2


select mf
Extract row ranges... 'lowerindexm':'upperindexm'
Rename... m
m = selected ("TableOfReal")


select mf
Extract row ranges... 'lowerindexf':'upperindexf'
Rename... f
f = selected ("TableOfReal")

select m
To PCA
m_pca = selected ("PCA")

select m
To Discriminant
m_dis =  selected ("Discriminant")
Extract group centroids
m_centroid = selected ("TableOfReal")

select f
To PCA
f_pca = selected ("PCA")

select f
To Discriminant
f_dis =  selected ("Discriminant")
Extract group centroids
f_centroid = selected ("TableOfReal")

procedure eigenvector_decoration texttop$
  Draw inner box
  Marks bottom every... 1 1 n y n
  One mark left... 1 y y n
  One mark left... 0 y y y
  One mark left... -1 y y n
  One mark bottom... 1 y n n
  One mark bottom... 18 y n n
  Text bottom... y Filter number
  Text top... n 'texttop$'
endproc

call vp1

select m_pca
Plain line
Draw eigenvector... 1 n 0 0 -1 1 1 + y n
select f_pca
Dotted line
Draw eigenvector... 1 n 0 0 -1 1 1 + y n
Plain line
call eigenvector_decoration (a) Eigenvector 1

call vp2

select m_pca
Draw eigenvector... 2 n 0 0 -1 1 1 + y n
select f_pca
Dotted line
Draw eigenvector... 2 n 0 0 -1 1 1 + y n
Plain line
call eigenvector_decoration (b) Eigenvector 2

call vp2a
call get_overall_means
call draw_means mg_centroid fg_centroid
Text top... n (c) Average vowel

call vp3 (130-80)/(130-60)

select m_pca
Invert eigenvector... 1
plus m_centroid
To Configuration... 2
m_conf = selected ("Configuration")

select m_pca
plus f_centroid
To Configuration... 2
f_conf = selected ("Configuration")

select m_conf
Draw... 1 2 60 130 80 130 10 y + y
select f_conf
Draw... 1 2 60 130 80 130 7 y + n
Marks bottom every... 1 10 n y n
Marks left every... 1 10 n y n
Text top... n (d) PCA

# the vectors

call get_mf_overall_means m f
# result tableofreal id = means_diff
call get_vector_from_diff m_pca f_centroid means_diff
# result tableofreal id  = table_appended
select table_appended
Draw vectors... 1 2 3 4 60 130 80 130 Line 0 n

call save pcs_PCA_m_f
  # height: (6.525959255093112-0.0825896762904641)*2.54 = 16.37
  # width = (4.994225721784777 - 0.32073490813648287)*2.54 = 11.87

pause Next: LDA
call vp1
select m_dis
Plain line
Draw eigenvector... 1 n 0 0 -1 1 1 + y n
select f_dis
Dotted line
Draw eigenvector... 1 n 0 0 -1 1 1 + y n
Plain line
call eigenvector_decoration (a) Eigenvector 1

call vp2
select m_dis
Draw eigenvector... 2 n 0 0 -1 1 1 + y n
select f_dis
Dotted line
Draw eigenvector... 2 n 0 0 -1 1 1 + y n
Plain line
call eigenvector_decoration (b) Eigenvector 2

call vp3 35/45

select m_dis
plus m_centroid
To Configuration... 2
m_conf = selected ("Configuration")

select m_dis
plus f_centroid
To Configuration... 2
f_conf = selected ("Configuration")

select m_conf
Set column label (index)... 1 Eigenvector 1
Set column label (index)... 2 Eigenvector 2
Draw... 1 2 -45 0 0 35 10 y + y

select f_conf
Draw... 1 2 -45 0 0 35 7 y + n
Marks bottom every... 1 10 n y n
Marks left every... 1 10 n y n
Text top... n (c) LDA

call get_vector_from_diff m_dis f_centroid means_diff
# result tableofreal id  = table_appended
select table_appended
Draw vectors... 1 2 3 4 -45 0 0 35 Line 0 n

call save pcs_LDA_m_f
# outer width  = (5.38792650918635 - 0.3207349081364828)*2.54 = 12.87
# outer height = (5.88853893263342 - 0.0825896762904641)*2.54 = 14.75

# Draw the overall means
procedure get_overall_means
  select m_dis
  Extract between-groups SSCP
  sscp_m = selected ("SSCP")
  Extract centroid
  mg_centroid = selected ("TableOfReal")
  select f_dis
  Extract between-groups SSCP
  sscp_f = selected ("SSCP")
  Extract centroid
  fg_centroid = selected ("TableOfReal")
  select sscp_m
  plus sscp_f
  Remove
endproc  

procedure draw_means m_id f_id
  select m_id
  To Matrix
  mat1= selected ("Matrix")
  Draw rows... 0 0 0 0 0 80  
  select f_id
  To Matrix
  mat2= selected ("Matrix")
  Dotted line
  Draw rows... 0 0 0 0 0 80
  Draw inner box
  Marks bottom every... 1 1 n y n
  Marks left every... 1 10 n y n
  One mark bottom... 1 y n n
  One mark bottom... 18 y n n
  One mark left... 80 y y n
  One mark left... 10 y y n
  Text bottom... y Filter number
  Text left... y dB
  select mat1
  plus mat2
  Remove
endproc
