# timit_test_vigilance_learningrate_2.praat
# 20040401 djmw
# 20040403 djmw changed scaling to [0,1] interval
# 20040407 djmw removed box plots

name$ = "timit_test_vigilance_learningrate_3"

savedir$ = "/home/david/tex/thesis/cart/"
datadir$ = "/home/david/tex/thesis/data/"
include /home/david/tex/praat_procedures.praat

call logfile_open 'name$'

artnet$ = "cart"
train$ = "train"
test$ = "train"

Create FuzzyCategoryART... 'artnet$' 9 1400
# 9 pc from the first 10 speakers in dr1 1228 items
# cpm0 dac0 dpk0 edr0 grl0 jeb1 jwt0 kls0 klw0 mgg0

Read from file... 'datadir$'barks_total_frame2_mf_meansperspeaker_pc9.TableOfReal
tmf = selected ("TableOfReal")

select tmf
Extract row ranges... 1:8079
tm = selected ("TableOfReal")

select tmf
Extract row ranges... 8079 : 11579
tf = selected ("TableOfReal")

test$ = "test"
Rename... 'test$'
Centre columns
Formula... (self+80)/160 
Formula... if self < 0 then 0 else if self > 1 then 1 else self fi fi  
Split into Pattern and Categories... 0 0 0 0

Read from file... 'savedir$'barks_d1R0SmP00A1_01_pc9_sp10.TableOfReal
Rename... 'train$'

Centre columns
Formula... (self+80)/160
Formula... if self < 0 then 0 else if self > 1 then 1 else self fi fi  

Split into Pattern and Categories... 0 0 0 0

procedure test
  nepoch = 2
  nrho = 2
  nbeta = 2
  nrep = 2
  epoch = 1
endproc

nrep = 10
nepoch = 10
nrho = 7
nbeta = 5
epoch = 20

#call test

rhob = 0.7
rhoe = 1
drho = (rhoe -rhob) / (nrho - 1)

betab = 0.05
betae = 1
dbeta = (betae - betab) / (nbeta - 1)

nrows = nrep * nepoch * nrho * nbeta * 2
ncols = 8
Create TableOfReal... results nrows ncols
Set column label (index)... 1 rep
Set column label (index)... 2 epoch
Set column label (index)... 3 rho
Set column label (index)... 4 beta
Set column label (index)... 5 frc
Set column label (index)... 6 commit
Set column label (index)... 7 track
Set column label (index)... 8 frct

procedure getfrc pcname$
  select FuzzyCategoryART 'artnet$'
  plus Pattern 'pcname$'
  To Categories
  select Categories 'pcname$'
  plus Categories untitled
  To Confusion
  frcc = Get fraction correct
  select Categories untitled
  plus Confusion untitled
  Remove
endproc

row = 0
for track from 0 to 1
  for rep to nrep
  # eigenlijk: rho = 0
    rho = rhob
    for j to nrho
      beta = betab
      for k to nbeta
        select FuzzyCategoryART 'artnet$'
        Reset... 0.001
        for l to nepoch
          select FuzzyCategoryART 'artnet$'
          plus Pattern 'train$'
          plus Categories 'train$'
          Learn... rho beta 'track' epoch Permutation 0
		  
	  call getfrc 'train$'
          frc = frcc
	  call getfrc 'test$'
	  frct = frcc

          select FuzzyCategoryART 'artnet$'
          ncommit = Get number of committed nodes
	  epochs = l*epoch
          datum$ = date$ ()	  
          logtext$ = "Rep,epoch,rho,beta,frc,ncommit,track,frct: 'datum$' 'rep' 'epochs' 'rho' 'beta' 'frc' 'ncommit' 'track' 'frct'"
          call logfile_append 'logtext$'
          select TableOfReal results
          row += 1
          Set value... row 1 rep
          Set value... row 2 epochs
          Set value... row 3 rho
          Set value... row 4 beta
          Set value... row 5 frc
          Set value... row 6 ncommit
          Set value... row 7 track
          Set value... row 8 frct
        endfor ; l
        select FuzzyCategoryART 'artnet$'
        ncommit = Get number of committed nodes
        plus Pattern 'train$'
        Prune category nodes
        select FuzzyCategoryART 'artnet$'
        ncommitp = Get number of committed nodes
        logtext$ = "-- Before/after pruning -- 'ncommit' 'ncommitp'"
        call logfile_append  'logtext$'
        beta += dbeta
        if beta>1
          beta = 1
        endif	  
      endfor ; k
      rho += drho
      if rho > 1
        rho = 1
      endif
    endfor ; j
  endfor ; rep
endfor ; track
  
call logfile_close

select TableOfReal results
Write to short text file... 'savedir$''name$'-'logfile_date$'.TableOfReal
